// Brute force the Ripper - MySQL 3 password cracker (CUDA+SSE3)
// Copyright (c) 2008 by Sergey E. Bogomolov
// Homepage: http://www.bog.pp.ru/
//
// This version of "Brute force the Ripper - MySQL 3" is hereby being made available to you
// under the terms of the GNU General Public License version 2 as published
// by the Free Software Foundation.
//
// "Brute force the Ripper - MySQL 3" is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

#undef GPU
#define CPU
#include "BtR-MySQL.h"

#ifdef SSE3

#define mmx_m2r(op,mem,reg) \
        __asm__ __volatile__ (#op " %0, %%" #reg \
                              : /* nothing */ \
                              : "m" (mem))
#define mmx_r2m(op,reg,mem) \
        __asm__ __volatile__ (#op " %%" #reg ", %0" \
                              : "=m" (mem) \
                              : /* nothing */ )
#define mmx_r2r(op,regs,regd) \
        __asm__ __volatile__ (#op " %" #regs ", %" #regd)
#define mmx_m2ri(op,mem,reg,imm) \
        __asm__ __volatile__ (#op " %1, %0, %%" #reg \
                              : /* nothing */ \
                              : "m" (mem), "i" (imm))
#define mmx_r2ri(op,regs,regd,imm) \
        __asm__ __volatile__ (#op " %0, %%" #regs ", %%" #regd \
                              : /* nothing */ \
                              : "i" (imm) )
#define mmx_si2r(op,imm,reg) \
        __asm__ __volatile__ (#op " %0, %%" #reg \
                              : /* nothing */ \
                              : "J" (imm) )


unsigned short iCharset_host[256] __attribute__ ((aligned(16)));
unsigned long bHash_SSE3 [2] __attribute__ ((aligned(16)));

void MySQL_CPU_fast_SSE3_init() {
	int i;
#ifdef CharsetInterval
  #if CharsetLen==26
	for( i = 0; i < CharsetLen; i++ ) iCharset_host[i] = i+'a';
  #else
    #if CharsetLen==75
	for( i = 0; i < CharsetLen; i++ ) iCharset_host[i] = i+'0';
    #else
	for( i = 0; i < CharsetLen; i++ ) iCharset_host[i] = i+'!';
    #endif
  #endif
#else
	unsigned char vszChars[256] = szChars;
	for( i = 0; i < CharsetLen; i++ ) iCharset_host[i] = vszChars[i];
#endif
	bHash_SSE3[0] = bHash_host[0];
	bHash_SSE3[1] = bHash_host[1];
}

void MySQL_CPU_fast_SSE3_7( ) {
        typedef unsigned long along __attribute__ ((aligned(16)));
        typedef unsigned short ashort __attribute__ ((aligned(16)));
        along nr = 1345345333L;
        ashort nr_and;
        const along mask = 0x7fffffff;
        unsigned short add = 7, c;
	unsigned long j;
//	unsigned long rr;

        c = hGetChar(nPassword_child[0]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[1]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[2]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        nr_and = (nr & 63) + add;
// 4*long
        mmx_m2ri (pshufd, mask, xmm4, 0);
	mmx_m2ri (pshufd, bHash_SSE3[0], xmm3, 0);
        mmx_m2ri (pshufd, nr, xmm6, 0);
// 8*short
        mmx_m2ri (pshuflw, nr_and, xmm7, 0);
        mmx_r2ri (pshufd, xmm7, xmm7, 0);
// nr << 8
        mmx_r2ri (pshufd, xmm6, xmm5, 0);
        mmx_si2r (pslld, 8, xmm5);

// nr_l = nr ^ (((nr & 63)+add) * c + (nr << 8));
// 24 команды внутри цикла на 8 паролей, 100 команд вне цикла
// для алфавита 96 символов: 100 + 24*12 команд = 388 команд / 96 паролей - 4 команды на пароль
        for( j = 0; j < CharsetLen; j += 8 ) {
//		mmx_r2m (movl, eax, rr);
		mmx_m2r (movdqa, iCharset_host[j], xmm0);

//      ((nr & 63)+add) * c
//      8 x short*short -> 2 x 4 x long
                mmx_r2r (movdqa, xmm7, xmm1);
                mmx_r2r (movdqa, xmm7, xmm2);
                mmx_r2r (pmullw, xmm0, xmm1);
                mmx_r2r (pmulhuw, xmm0, xmm2);
                mmx_r2r (movdqa, xmm1, xmm0);
                mmx_r2r (punpcklwd, xmm2, xmm1);
                mmx_r2r (punpckhwd, xmm2, xmm0);
//      ... + (nr<<8) ^ nr & 0x7fffffff, если хоть одно равенство с bHash, то не -1 в ResultFlag
                mmx_r2r (paddd, xmm5, xmm0);
                mmx_r2r (pxor, xmm6, xmm0);
                mmx_r2r (pand, xmm4, xmm0);
                mmx_r2r (pcmpeqd, xmm3, xmm0);
		mmx_r2r (pmovmskb, xmm0, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 98f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("98:");
// вторая четвёрка
                mmx_r2r (paddd, xmm5, xmm1);
                mmx_r2r (pxor, xmm6, xmm1);
                mmx_r2r (pand, xmm4, xmm1);
                mmx_r2r (pcmpeqd, xmm3, xmm1);
		mmx_r2r (pmovmskb, xmm1, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 99f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("99:");

//		mmx_m2r (movl, rr, eax);
        }
}

void MySQL_CPU_fast_SSE3_8( ) {
        typedef unsigned long along __attribute__ ((aligned(16)));
        typedef unsigned short ashort __attribute__ ((aligned(16)));
        along nr = 1345345333L;
        ashort nr_and;
        const along mask = 0x7fffffff;
        unsigned short add = 7, c;
	unsigned long j;
//	unsigned long rr;

        c = hGetChar(nPassword_child[0]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[1]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[2]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[3]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        nr_and = (nr & 63) + add;
// 4*long
        mmx_m2ri (pshufd, mask, xmm4, 0);
	mmx_m2ri (pshufd, bHash_SSE3[0], xmm3, 0);
        mmx_m2ri (pshufd, nr, xmm6, 0);
// 8*short
        mmx_m2ri (pshuflw, nr_and, xmm7, 0);
        mmx_r2ri (pshufd, xmm7, xmm7, 0);
// nr << 8
        mmx_r2ri (pshufd, xmm6, xmm5, 0);
        mmx_si2r (pslld, 8, xmm5);

// nr_l = nr ^ (((nr & 63)+add) * c + (nr << 8));
// 24 команды внутри цикла на 8 паролей, 100 команд вне цикла
// для алфавита 96 символов: 100 + 24*12 команд = 388 команд / 96 паролей - 4 команды на пароль
        for( j = 0; j < CharsetLen; j += 8 ) {
//		mmx_r2m (movl, eax, rr);
		mmx_m2r (movdqa, iCharset_host[j], xmm0);

//      ((nr & 63)+add) * c
//      8 x short*short -> 2 x 4 x long
                mmx_r2r (movdqa, xmm7, xmm1);
                mmx_r2r (movdqa, xmm7, xmm2);
                mmx_r2r (pmullw, xmm0, xmm1);
                mmx_r2r (pmulhuw, xmm0, xmm2);
                mmx_r2r (movdqa, xmm1, xmm0);
                mmx_r2r (punpcklwd, xmm2, xmm1);
                mmx_r2r (punpckhwd, xmm2, xmm0);
//      ... + (nr<<8) ^ nr & 0x7fffffff, если хоть одно равенство с bHash, то не -1 в ResultFlag
                mmx_r2r (paddd, xmm5, xmm0);
                mmx_r2r (pxor, xmm6, xmm0);
                mmx_r2r (pand, xmm4, xmm0);
                mmx_r2r (pcmpeqd, xmm3, xmm0);
		mmx_r2r (pmovmskb, xmm0, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 98f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("98:");
// вторая четвёрка
                mmx_r2r (paddd, xmm5, xmm1);
                mmx_r2r (pxor, xmm6, xmm1);
                mmx_r2r (pand, xmm4, xmm1);
                mmx_r2r (pcmpeqd, xmm3, xmm1);
		mmx_r2r (pmovmskb, xmm1, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 99f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("99:");

//		mmx_m2r (movl, rr, eax);
        }
}

void MySQL_CPU_fast_SSE3_9( ) {
        typedef unsigned long along __attribute__ ((aligned(16)));
        typedef unsigned short ashort __attribute__ ((aligned(16)));
        along nr = 1345345333L;
        ashort nr_and;
        const along mask = 0x7fffffff;
        unsigned short add = 7, c;
	unsigned long j;
//	unsigned long rr;

        c = hGetChar(nPassword_child[0]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[1]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[2]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[3]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[4]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        nr_and = (nr & 63) + add;
// 4*long
        mmx_m2ri (pshufd, mask, xmm4, 0);
	mmx_m2ri (pshufd, bHash_SSE3[0], xmm3, 0);
        mmx_m2ri (pshufd, nr, xmm6, 0);
// 8*short
        mmx_m2ri (pshuflw, nr_and, xmm7, 0);
        mmx_r2ri (pshufd, xmm7, xmm7, 0);
// nr << 8
        mmx_r2ri (pshufd, xmm6, xmm5, 0);
        mmx_si2r (pslld, 8, xmm5);

// nr_l = nr ^ (((nr & 63)+add) * c + (nr << 8));
// 24 команды внутри цикла на 8 паролей, 100 команд вне цикла
// для алфавита 96 символов: 100 + 24*12 команд = 388 команд / 96 паролей - 4 команды на пароль
        for( j = 0; j < CharsetLen; j += 8 ) {
//		mmx_r2m (movl, eax, rr);
		mmx_m2r (movdqa, iCharset_host[j], xmm0);

//      ((nr & 63)+add) * c
//      8 x short*short -> 2 x 4 x long
                mmx_r2r (movdqa, xmm7, xmm1);
                mmx_r2r (movdqa, xmm7, xmm2);
                mmx_r2r (pmullw, xmm0, xmm1);
                mmx_r2r (pmulhuw, xmm0, xmm2);
                mmx_r2r (movdqa, xmm1, xmm0);
                mmx_r2r (punpcklwd, xmm2, xmm1);
                mmx_r2r (punpckhwd, xmm2, xmm0);
//      ... + (nr<<8) ^ nr & 0x7fffffff, если хоть одно равенство с bHash, то не -1 в ResultFlag
                mmx_r2r (paddd, xmm5, xmm0);
                mmx_r2r (pxor, xmm6, xmm0);
                mmx_r2r (pand, xmm4, xmm0);
                mmx_r2r (pcmpeqd, xmm3, xmm0);
		mmx_r2r (pmovmskb, xmm0, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 98f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("98:");
// вторая четвёрка
                mmx_r2r (paddd, xmm5, xmm1);
                mmx_r2r (pxor, xmm6, xmm1);
                mmx_r2r (pand, xmm4, xmm1);
                mmx_r2r (pcmpeqd, xmm3, xmm1);
		mmx_r2r (pmovmskb, xmm1, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 99f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("99:");

//		mmx_m2r (movl, rr, eax);
        }
}

void MySQL_CPU_fast_SSE3_10( ) {
        typedef unsigned long along __attribute__ ((aligned(16)));
        typedef unsigned short ashort __attribute__ ((aligned(16)));
        along nr = 1345345333L;
        ashort nr_and;
        const along mask = 0x7fffffff;
        unsigned short add = 7, c;
	unsigned long j;
//	unsigned long rr;

        c = hGetChar(nPassword_child[0]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[1]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[2]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[3]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[4]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(nPassword_child[5]);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        nr_and = (nr & 63) + add;
// 4*long
        mmx_m2ri (pshufd, mask, xmm4, 0);
	mmx_m2ri (pshufd, bHash_SSE3[0], xmm3, 0);
        mmx_m2ri (pshufd, nr, xmm6, 0);
// 8*short
        mmx_m2ri (pshuflw, nr_and, xmm7, 0);
        mmx_r2ri (pshufd, xmm7, xmm7, 0);
// nr << 8
        mmx_r2ri (pshufd, xmm6, xmm5, 0);
        mmx_si2r (pslld, 8, xmm5);

// nr_l = nr ^ (((nr & 63)+add) * c + (nr << 8));
// 24 команды внутри цикла на 8 паролей, 100 команд вне цикла
// для алфавита 96 символов: 100 + 24*12 команд = 388 команд / 96 паролей - 4 команды на пароль
        for( j = 0; j < CharsetLen; j += 8 ) {
//		mmx_r2m (movl, eax, rr);
		mmx_m2r (movdqa, iCharset_host[j], xmm0);

//      ((nr & 63)+add) * c
//      8 x short*short -> 2 x 4 x long
                mmx_r2r (movdqa, xmm7, xmm1);
                mmx_r2r (movdqa, xmm7, xmm2);
                mmx_r2r (pmullw, xmm0, xmm1);
                mmx_r2r (pmulhuw, xmm0, xmm2);
                mmx_r2r (movdqa, xmm1, xmm0);
                mmx_r2r (punpcklwd, xmm2, xmm1);
                mmx_r2r (punpckhwd, xmm2, xmm0);
//      ... + (nr<<8) ^ nr & 0x7fffffff, если хоть одно равенство с bHash, то не -1 в ResultFlag
                mmx_r2r (paddd, xmm5, xmm0);
                mmx_r2r (pxor, xmm6, xmm0);
                mmx_r2r (pand, xmm4, xmm0);
                mmx_r2r (pcmpeqd, xmm3, xmm0);
		mmx_r2r (pmovmskb, xmm0, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 98f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("98:");
// вторая четвёрка
                mmx_r2r (paddd, xmm5, xmm1);
                mmx_r2r (pxor, xmm6, xmm1);
                mmx_r2r (pand, xmm4, xmm1);
                mmx_r2r (pcmpeqd, xmm3, xmm1);
		mmx_r2r (pmovmskb, xmm1, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 99f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("99:");

//		mmx_m2r (movl, rr, eax);
        }
}

void MySQL_CPU_fast_SSE3_univ( ) {
        typedef unsigned long along __attribute__ ((aligned(16)));
        typedef unsigned short ashort __attribute__ ((aligned(16)));
        along nr = 1345345333L;
        ashort nr_and;
        const along mask = 0x7fffffff;
        unsigned short add = 7, c;
	unsigned long i, j;
//	unsigned long rr;

        for( i = 0; i < nPasswordLen_child; i++ ) {
                c = hGetChar(nPassword_child[i]);
                nr^= FMULhost(((nr & 63)+add), c) + (nr << 8);
                add+=c;
        }

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        nr_and = (nr & 63) + add;
// 4*long
        mmx_m2ri (pshufd, mask, xmm4, 0);
	mmx_m2ri (pshufd, bHash_SSE3[0], xmm3, 0);
//	mmx_m2ri (pshufd, bHash_host[0], xmm3, 0);
        mmx_m2ri (pshufd, nr, xmm6, 0);
// 8*short
        mmx_m2ri (pshuflw, nr_and, xmm7, 0);
        mmx_r2ri (pshufd, xmm7, xmm7, 0);
// nr << 8
        mmx_r2ri (pshufd, xmm6, xmm5, 0);
        mmx_si2r (pslld, 8, xmm5);

// nr_l = nr ^ (((nr & 63)+add) * c + (nr << 8));
// 24 команды внутри цикла на 8 паролей, 100 команд вне цикла
// для алфавита 96 символов: 100 + 24*12 команд = 388 команд / 96 паролей - 4 команды на пароль
        for( j = 0; j < CharsetLen; j += 8 ) {
//		mmx_r2m (movl, eax, rr);
		mmx_m2r (movdqa, iCharset_host[j], xmm0);

//      ((nr & 63)+add) * c
//      8 x short*short -> 2 x 4 x long
                mmx_r2r (movdqa, xmm7, xmm1);
                mmx_r2r (movdqa, xmm7, xmm2);
                mmx_r2r (pmullw, xmm0, xmm1);
                mmx_r2r (pmulhuw, xmm0, xmm2);
                mmx_r2r (movdqa, xmm1, xmm0);
                mmx_r2r (punpcklwd, xmm2, xmm1);
                mmx_r2r (punpckhwd, xmm2, xmm0);
//      ... + (nr<<8) ^ nr & 0x7fffffff, если хоть одно равенство с bHash, то не -1 в ResultFlag
                mmx_r2r (paddd, xmm5, xmm0);
                mmx_r2r (pxor, xmm6, xmm0);
                mmx_r2r (pand, xmm4, xmm0);
                mmx_r2r (pcmpeqd, xmm3, xmm0);
		mmx_r2r (pmovmskb, xmm0, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 98f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("98:");
// вторая четвёрка
                mmx_r2r (paddd, xmm5, xmm1);
                mmx_r2r (pxor, xmm6, xmm1);
                mmx_r2r (pand, xmm4, xmm1);
                mmx_r2r (pcmpeqd, xmm3, xmm1);
		mmx_r2r (pmovmskb, xmm1, eax);
		__asm__ __volatile__ (
			"testl %eax, %eax\n"
			"je 99f");
		__asm__ __volatile__ (" movl %%eax, %0; \n" : "=m" (ResultFlag_child) : : "%eax");
		__asm__ __volatile__ ("99:");

//		mmx_m2r (movl, rr, eax);
        }

}

#endif

void MySQL_CPU_fast( )
{
        unsigned long nr = 1345345333L;
        unsigned long nr_l;
        unsigned short add = 7, c;
	unsigned long i, j;

        for( i = 0; i < nPasswordLen_child; i++ ) {
                c = hGetChar(nPassword_child[i]);
                nr^= FMULhost(((nr & 63)+add), c) + (nr << 8);
                add+=c;
        }

	c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        add+=c;

        for( j = 0; j < CharsetLen; j++ ) {
                c = hGetChar(j);
                nr_l = nr ^ (FMULhost(((nr & 63)+add), c) + (nr << 8));
                if( (nr_l & 0x7fffffff) == bHash_host[0] ) ResultFlag_child = 1;
        }
}

void MySQL_CPU( )
{
        unsigned long nr = 1345345333L, nr_l;
        unsigned long nr2 = 0x12345671L, nr2_l;
        unsigned short add = 7, c;
	unsigned long i, j;

        for( i = 0; i < nPasswordLen_child; i++ ) {
                c = hGetChar(nPassword_child[i]);
                nr^= FMULhost(((nr & 63)+add), c) + (nr << 8);
                nr2+=(nr2 << 8) ^ nr;
                add+=c;
        }

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        for( j = 0; j < CharsetLen; j++ ) {
                c = hGetChar(j);
                nr_l = nr ^ (FMULhost(((nr & 63)+add), c) + (nr << 8));
                nr2_l = nr2 + ((nr2 << 8) ^ nr_l);

                if( (nr_l & 0x7fffffff) == bHash_host[0] )
                        if( (nr2_l & 0x7fffffff) == bHash_host[1] ) 
                                ResultFlag_child = (blockIdx_child.x << 24) | (blockIdx_child.y << 16) |
                                                (threadIdx_child.x << 8) | j;
        }
}

int MySQL_CPU_check( )
{
        unsigned long nr = 1345345333L;
        unsigned long nr2 = 0x12345671L;
        unsigned short add = 7, c;
	unsigned long i;

        for( i = 0; i < nPasswordLen_child; i++ ) {
                c = hGetChar(nPassword_child[i]);
                nr^= FMULhost(((nr & 63)+add), c) + (nr << 8);
                nr2+=(nr2 << 8) ^ nr;
                add+=c;
        }

        c = hGetChar(blockIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        c = hGetChar(blockIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        c = hGetChar(threadIdx_child.x);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;
        add+=c;

        c = hGetChar(threadIdx_child.y);
        nr^= FMULhost(((nr & 63)+add),c) + (nr << 8);
        nr2+=(nr2 << 8) ^ nr;

        if( (nr & 0x7fffffff) == bHash_host[0] )
        	if( (nr2 & 0x7fffffff) == bHash_host[1] ) 
			return 1;
	return 0;
}

