// Brute force the Ripper - MySQL 3 password cracker (CUDA+SSE3)
// Copyright (c) 2008 by Sergey E. Bogomolov
// Homepage: http://www.bog.pp.ru/
//
// This version of "Brute force the Ripper - MySQL 3" is hereby being made available to you
// under the terms of the GNU General Public License version 2 as published
// by the Free Software Foundation.
//
// "Brute force the Ripper - MySQL 3" is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.


#define GPU
#undef CPU
#include "BtR-MySQL.h"

// Q6600@3.3 + GeForce8600GT + GTX 260
// CharLen=94, CharsetInterval
/*
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 10
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: -1
		44485.91M
	
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 10
        CUDA sync pause: -1
        CPUs threads affinity: 0
        GPU threads affinity to CPU: -1
		44258.26M
 */

/*
        Charset length: 94
        Charset interval
        minimal password length: 8
        maximal password length: 16
        tasks queue length per thread: 6
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 1
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: 3
        threads per GPU: 1
		46145.49M
 */

// CharLen=26, CharsetInterval
/*
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 10
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: 3
		7438.84M
*/

// CharLen=75, CharsetInterval
/*
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 10
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: 3
		37385.62M
 */

// CharLen=62

/*
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 10
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: 3
		33406.11M
 */

/*
	Charset length: 36
        minimal password length: 8
        tasks queue length per thread: 6
        CPU numbers: 4
        GPU numbers: 2
        CPUs threads priority: 19
        GPUs threads priority: 1
        CUDA sync pause: 0
        CPUs threads affinity: 0
        GPU threads affinity to CPU: 3
        threads per GPU: 1
        tasks per GPU thread: 2
		17325.40M
 */

// MySQL("password") = 5d2e1939 3cc5ef67
//unsigned char cHash[8] = { 0x5d,0x2e,0x19,0x39,0x3c,0xc5,0xef,0x67 };
// MySQL (root/?)
unsigned char cHash[8] = { 0x16,0x9f,0xbc,0xa4,0x2b,0xc4,0xec,0xc6 };
// MySQL (zennos) = 6ff3ad14 776a2091
//unsigned char cHash[8] = { 0x6f,0xf3,0xad,0x14,0x77,0x6a,0x20,0x91 };
// MySQL("drew") = 697a7de87c5390b2
// unsigned char cHash[8] = { 0x69,0x7a,0x7d,0xe8,0x7c,0x53,0x90,0xb2 };
// MySQL("probe") = 445ff82636a7ba59
//unsigned char cHash[8] = { 0x44,0x5f,0xf8,0x26,0x36,0xa7,0xba,0x59 };
// MySQL("hacker") = 77ff75006118bab8
//unsigned char cHash[8] = { 0x77,0xff,0x75,0x00,0x61,0x18,0xba,0xb8 };

__global__ void MySQL_GPU_fast_7( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2_fast_7( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPUD_fast_7( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}

	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU_fast_8( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;


	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2_fast_8( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;


	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPUD_fast_8( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}

	nr = 1345345333L;
	add = 7;

	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU_fast_9( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2_fast_9( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;


	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPUD_fast_9( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}

	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU_fast_10( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;


	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[5]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2_fast_10( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;


	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[5]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPUD_fast_10( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	c = GetChar(nPassword_GPU[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU[5]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}

	c = GetChar(nPassword_GPU2[0]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[1]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[2]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[3]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[4]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(nPassword_GPU2[5]);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) | (threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU_fast_univ( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	for( unsigned long i = 0; i < nPasswordLen_GPU; i++ ) {
		c = GetChar(nPassword_GPU[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2_fast_univ( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	for( unsigned long i = 0; i < nPasswordLen_GPU2; i++ ) {
		c = GetChar(nPassword_GPU2[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPUD_fast_univ( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long c;

	for( unsigned long i = 0; i < nPasswordLen_GPU; i++ ) {
		c = GetChar(nPassword_GPU[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}

	for( unsigned long i = 0; i < nPasswordLen_GPU2; i++ ) {
		c = GetChar(nPassword_GPU2[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr_l &= 0x7fffffff;
// обход ошибки в оптимизаторе
		if( nr_l == bHash_GPU[0] )
			if( nr_l == bHash_GPU[0] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}
}

#if 0
__global__ void MySQL_GPU( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long nr2 = 0x12345671L, nr2_l;
	unsigned long c;

	for( unsigned long i = 0; i < nPasswordLen_GPU; i++ ) {
		c = GetChar(nPassword_GPU[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		nr2+=(nr2 << 8) ^ nr;
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr2_l = nr2 + ((nr2 << 8) ^ nr_l);
		nr2_l &= 0x7fffffff;
		nr_l &= 0x7fffffff;

		if( nr_l == bHash_GPU[0] )
			if( nr2_l == bHash_GPU[1] ) 
				ResultFlag_GPU[0] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}
}

__global__ void MySQL_GPU2( )
{
	unsigned long nr = 1345345333L, add = 7, nr_l;
	unsigned long nr2 = 0x12345671L, nr2_l;
	unsigned long c;

	for( unsigned long i = 0; i < nPasswordLen_GPU2; i++ ) {
		c = GetChar(nPassword_GPU2[i]);
		nr^= FMUL(((nr & 63)+add), c) + (nr << 8);
		nr2+=(nr2 << 8) ^ nr;
		add+=c;
	}

	c = GetChar(blockIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;

	c = GetChar(blockIdx.y);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;

	c = GetChar(threadIdx.x);
	nr^= FMUL(((nr & 63)+add),c) + (nr << 8);
	nr2+=(nr2 << 8) ^ nr;
	add+=c;
#pragma unroll
	for( unsigned long j = 0; j < CharsetLen; j++ ) {
		c = GetChar(j);
		nr_l = nr ^ (FMUL(((nr & 63)+add), c) + (nr << 8));
		nr2_l = nr2 + ((nr2 << 8) ^ nr_l);
		nr2_l &= 0x7fffffff;
		nr_l &= 0x7fffffff;

		if( nr_l == bHash_GPU[0] )
			if( nr2_l == bHash_GPU[1] ) 
				ResultFlag_GPU[1] = (blockIdx.x << 24) | (blockIdx.y << 16) |
						(threadIdx.x << 8) | j;
	}
}
#endif

void cudaRunAndCheck (cudaError_t rc, char *string, int child) {
	if (rc != cudaSuccess ) {
		printf (" ! function %s (child %d) failed: %s\n", string, child, cudaGetErrorString( rc ));
		exit (EXIT_FAILURE);
	}
}

void cudaSync (int sync_pause, int child, cudaStream_t stream) {
	cudaError_t rc;

	if (sync_pause < 0) {
		cudaRunAndCheck (cudaThreadSynchronize(), "cudaThreadSynchronize", child);
	} else if (sync_pause) {
		while (1) {
			rc = cudaStreamQuery( stream );
			if( rc != cudaErrorNotReady ) break;
			usleep (sync_pause);
		}
	} else {
		while (1) {
			rc = cudaStreamQuery( stream );
			if( rc != cudaErrorNotReady ) break;
			sched_yield();
		}
	}
}

void btr_usage () {
	printf ("Brute force the Ripper - MySQL 3 password cracker\n");
	printf ("Copyright (c) 2008 by Sergey E. Bogomolov\n");
	printf ("Homepage: http://www.bog.pp.ru/\n");
	printf ("\n");
	printf ("Usage: BtR-MySQL [OPTIONS]\n");
	printf ("--help\n");
	printf ("--verbose\n");
	printf ("--min		minimal password length (> 5, <= 16, default: %d)\n", PasswordLen_Min);
	printf ("--max		maximal password length (> 5, <= 16, default: %d)\n", PasswordLen_Max);
	printf ("--queue	tasks queue length per thread (default: %d)\n", QUEUE_LENG);
	printf ("--cpus		maximal CPU numbers (0 - turn off CPU usage)\n");
	printf ("--gpus		maximal GPU numbers (0 - turn off GPU usage, default: %d)\n", GPU_SETSIZE);
	printf ("--cpunice	CPUs threads priority (0 - no change, default: %d)\n", CPU_NICE);
	printf ("--gpunice	GPUs threads priority (0 - no change, default: %d)\n", GPU_NICE);
	printf ("--syncpause	CUDA sync pause (0 - sched_yield, -1 - loop check, default: %d)\n", SYNC_PAUSE);
	printf ("--nocpua	no CPUs threads affinity\n");
	printf ("--gpucpu	GPUs threads to CPU affinity (-1 - no affinity, default: %d)\n", GPU_CPU);
	printf ("--gputhreads	threads per GPU (default: %d, max: %d)\n", THREADS_PER_GPU, THREADS_PER_GPU_MAX);
	printf ("--tasks	tasks per GPU threads (default: %d, max: %d)\n", TASKS_PER_THREAD, TASKS_PER_THREAD_MAX);
	printf ("\n");
	
	exit (EXIT_FAILURE);
}
	
int main(int argc, char* argv[]) {
	long nResult[2] = {-1, -1};

	cudaStream_t stream, stream2;
	cudaDeviceProp prop[GPU_SETSIZE*THREADS_PER_GPU_MAX];
	dim3 grid(CharsetLen, CharsetLen, 1);

	int i;
	long long count = 0;
//	long long child_count = 0;
//	long long child_recount = 0;

	time_t start, prev, cur;

	struct cpu_child {
		pid_t pid;
		int queue;
		int cpu;
		int gpu;
		cpu_set_t cpumask; 
		int pipefd_task[2];
		int pipefd_result[2];
	};
	struct cpu_child cpu_childs [CPU_SETSIZE+GPU_SETSIZE*THREADS_PER_GPU_MAX];
	cpu_set_t cpumask_parent;
	int gpu_childs_num = 0, cpu_childs_num = 0, child_num;
	pid_t child_pid;
	int parent = 1;
	ssize_t rcount, wcount;
//	int fd_flags;
	struct pollfd poll_fds [CPU_SETSIZE+GPU_SETSIZE*THREADS_PER_GPU_MAX];

	int longindex, do_help=0, do_verbose=0, 
		PasswordLen_min=PasswordLen_Min, PasswordLen_max=PasswordLen_Max, 
		queue_leng=QUEUE_LENG,
		used_cpu=CPU_SETSIZE, cpu_nice=CPU_NICE, used_gpu=GPU_SETSIZE, gpu_nice=GPU_NICE,
		sync_pause=SYNC_PAUSE, 
		cpu_affinity=1, gpu_cpu=GPU_CPU, 
		threads_per_gpu=THREADS_PER_GPU, tasks_per_thread=TASKS_PER_THREAD;
	struct option longopts[] = {
		{ "help", no_argument, &do_help, 1},
		{ "verbose", no_argument, &do_verbose, 1},
		{ "min", required_argument, NULL, 12},
		{ "max", required_argument, NULL, 13},
		{ "cpus", required_argument, NULL, 14},
		{ "gpus", required_argument, NULL, 15},
		{ "cpunice", required_argument, NULL, 16},
		{ "gpunice", required_argument, NULL, 17},
		{ "syncpause", required_argument, NULL, 18},
		{ "nocpua", no_argument, &cpu_affinity, 0},
		{ "gpucpu", required_argument, NULL, 19},
		{ "gputhreads", required_argument, NULL, 20},
		{ "tasks", required_argument, NULL, 21},
		{ "queue", required_argument, NULL, 22},
		{ 0, 0, 0, 0 }
	};

#ifndef CharsetInterval
	unsigned long nCharset_host[256] = { 0 };
	unsigned char vszChars[256] = szChars;
	for( i = 0; i < CharsetLen; i++ ) nCharset_host[i] = vszChars[i];
	for( i = 0; i < CharsetLen; i++ ) cCharset_host[i] = vszChars[i];
#endif

	while (( i = getopt_long (argc, argv, "", longopts, &longindex)) != -1) {
		switch (i) {
		case 0:
			break;
		case '?':
			printf ("%s: option requires an argument\n", argv[0]);
			btr_usage();
			break;
		case ':':
			printf ("%s: option is invalid\n", argv[0]);
			btr_usage();
			break;
		case 1:
			break;
		case 12:
			PasswordLen_min = atoi (optarg);
			if (PasswordLen_min < PasswordLen_Min) btr_usage();
			if (PasswordLen_min > 16) btr_usage();
			break;
		case 13:
			PasswordLen_max = atoi (optarg);
			if (PasswordLen_max < PasswordLen_Min) btr_usage();
			if (PasswordLen_max > 16) btr_usage();
			break;
		case 14:
			used_cpu = atoi (optarg);
			if (used_cpu < 0) used_cpu = 0;
			break;
		case 15:
			used_gpu = atoi (optarg);
			if (used_gpu < 0) used_gpu = 0;
			break;
		case 16:
			cpu_nice = atoi (optarg);
			if (cpu_nice < 0) btr_usage();
			if (cpu_nice > 19) btr_usage();
			break;
		case 17:
			gpu_nice = atoi (optarg);
			if (gpu_nice < 0) btr_usage();
			if (gpu_nice > 19) btr_usage();
			break;
		case 18:
			sync_pause = atoi (optarg);
			break;
		case 19:
			gpu_cpu = atoi (optarg);
			break;
		case 20:
			threads_per_gpu = atoi (optarg);
			if (threads_per_gpu < 1 || threads_per_gpu > THREADS_PER_GPU_MAX) btr_usage();
			break;
		case 21:
			tasks_per_thread = atoi (optarg);
			if (tasks_per_thread < 1 || tasks_per_thread > TASKS_PER_THREAD_MAX) btr_usage();
			break;
		case 22:
			queue_leng = atoi (optarg);
			if (queue_leng < 1) btr_usage();
			break;
		default:
			btr_usage();
		}
	}
	if (do_help) btr_usage();
	if (PasswordLen_max < PasswordLen_min) btr_usage();
	if (tasks_per_thread > 1 && threads_per_gpu > 1) btr_usage();

//	for( i=0; i<2; i++) {
//		bHash_host[i] = cHash[i*4+3] | (cHash[i*4+2] << 8) | (cHash[i*4+1] << 16) | (cHash[i*4] << 24);
//	}

	if (scanf ("%8lx %8lx", &bHash_host[0], &bHash_host[1]) != 2) btr_usage();

	MySQL_CPU_fast_SSE3_init();

	ResultFlag_host = ResultFlag_child = nResult[0];
	prev = start = time( NULL );

/* CPU check */
        if( sched_getaffinity (0, sizeof(cpu_set_t), &cpumask_parent) ) {
                printf ("! sched_getaffinity error\n");
                return EXIT_FAILURE;
	} 
	if (do_verbose) {
		printf ("CPU mask:");
		for (i=0; i<sizeof(cpu_set_t)/sizeof(__cpu_mask); i++) printf (" %08lx", cpumask_parent.__bits[i]);
		printf ("\n");
        }
	child_num = 0;

        for (i=0; i<CPU_SETSIZE; i++) {
		if (child_num >= used_cpu) break;
                if (CPU_ISSET (i, &cpumask_parent)) {
                        if (pipe (cpu_childs[child_num].pipefd_task) < 0) {
                                printf ("! pipe error (task), child: %d\n", child_num);
                                return EXIT_FAILURE;
                        }
                        if (pipe (cpu_childs[child_num].pipefd_result) < 0) {
                                printf ("! pipe error (result), child: %d\n", child_num);
                                return EXIT_FAILURE;
                        }
//                      if ((fd_flags = fcntl(cpu_childs[child_num].pipefd_result[0], F_GETFL, 0)) < 0 ) {
//                              printf ("!  fcntl get error (result), child: %d\n", child_num);
//                              return EXIT_FAILURE;
//                      }
//                      if (fcntl(cpu_childs[child_num].pipefd_result[0], F_SETFL, fd_flags | O_NONBLOCK) != 0) {
//                              printf ("!  fcntl set error (result), child: %d\n", child_num);
//                              return EXIT_FAILURE;
//                      }
                        child_pid = fork();
                        if (child_pid == 0) {
				if (do_verbose) printf ("cpu child %d\n", child_num);
				nice (cpu_nice);
				parent = 0;
                                break;
                        }
                        if (child_pid < 0) {
                                printf ("! fork error, child: %d\n", child_num);
                                return EXIT_FAILURE;
                        }
			if (do_verbose) printf ("parent of cpu child %d, pid: %d\n", child_num, child_pid);
                        cpu_childs[child_num].pid = child_pid;
			if (cpu_affinity) {
	                        CPU_SET (i, &cpu_childs[child_num].cpumask);
	                        if( sched_setaffinity (child_pid, sizeof(cpu_set_t), &cpu_childs[child_num].cpumask) ) {
	                                printf ("! sched_setaffinity error, child: %d\n", child_num);
	                                return EXIT_FAILURE;
	                        }
			}
                        poll_fds[child_num].fd = cpu_childs[child_num].pipefd_result[0];
                        poll_fds[child_num].events = POLLIN;
			cpu_childs[child_num].cpu = 1;
			cpu_childs[child_num].gpu = 0;
                        cpu_childs[child_num].queue = 0;
                        child_num++;
                }
        }

        cpu_childs_num = child_num;

	if (parent) {
/* GPU check */
		gpu_childs_num = used_gpu;
//		cudaRunAndCheck (cudaGetDeviceCount( &gpu_childs_num ), "cudaGetDeviceCount", 0);
//		if (gpu_childs_num > used_gpu) gpu_childs_num = used_gpu;
//		if( gpu_childs_num < 1 ) {
//			printf( " ! No compatible device found.\n" );
//			return EXIT_FAILURE;
//		}
//		printf( " + Number of CUDA devices present: %d\n", gpu_childs_num );
//		for (i=0; i<gpu_childs_num; i++) {
//			cudaRunAndCheck (cudaGetDeviceProperties( &prop[i], i ), "cudaGetDeviceProperties", i);
//			printf( " + Device %d(%s): %d MOP at %d MHz\n", i, 
//				prop[i].name, prop[i].multiProcessorCount, prop[i].clockRate/1000);
//		}
//		printf ("\n");
////		cudaRunAndCheck (cudaThreadExit(), "cudaThreadExit", 0);
		gpu_childs_num = gpu_childs_num * threads_per_gpu;

		for (child_num=cpu_childs_num; child_num<cpu_childs_num+gpu_childs_num; child_num++) {
			if (pipe (cpu_childs[child_num].pipefd_task) < 0) {
				printf ("! pipe error (task), gpu child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if (pipe (cpu_childs[child_num].pipefd_result) < 0) {
				printf ("! pipe error (result), gpu child: %d\n", child_num);
				return EXIT_FAILURE;
			}
//			if ((fd_flags = fcntl(cpu_childs[child_num].pipefd_result[0], F_GETFL, 0)) < 0 ) {
//				printf ("!  fcntl get error (result), gpu child: %d\n", child_num);
//				return EXIT_FAILURE;
//			}
//			if (fcntl(cpu_childs[child_num].pipefd_result[0], F_SETFL, fd_flags | O_NONBLOCK) != 0) {
//				printf ("!  fcntl set error (result), gpu child: %d\n", child_num);
//				return EXIT_FAILURE;
//			}
//			cudaRunAndCheck (cudaSetDevice( (child_num-cpu_childs_num)/threads_per_gpu ), "cudaSetDevice", child_num);
//			cudaRunAndCheck (cudaThreadSynchronize(), "cudaThreadSynchronize", child_num);
			cpu_childs[child_num].cpu = 0;
			cpu_childs[child_num].gpu = 1;
			child_pid = fork();
			if (child_pid == 0) {
				if (do_verbose) printf ("gpu child %d\n", child_num);
				nice (gpu_nice);
				parent = 0;
				break;
			}
			if (child_pid < 0) {
				printf ("! fork error, gpu child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if (do_verbose) printf ("parent of gpu child %d, pid: %d\n", child_num, child_pid);
			cpu_childs[child_num].pid = child_pid;
			if (gpu_cpu >= 0 && gpu_cpu < cpu_childs_num) {
				CPU_SET (gpu_cpu, &cpu_childs[child_num].cpumask);
				if( sched_setaffinity (child_pid, sizeof(cpu_set_t), &cpu_childs[child_num].cpumask) ) {
					printf ("! sched_setaffinity error, gpu child: %d\n", child_num);
					return EXIT_FAILURE;
				}
			}
			poll_fds[child_num].fd = cpu_childs[child_num].pipefd_result[0];
			poll_fds[child_num].events = POLLIN;
			cpu_childs[child_num].queue = 0;
//			cudaRunAndCheck (cudaThreadExit(), "cudaThreadExit", 0);
		}
	}
	if (parent) {
		if (do_verbose) {
			printf ("\n");
			printf ("Brute force the Ripper - MySQL 3 password cracker\n");
			printf ("Copyright (c) 2008 by Sergey E. Bogomolov\n");
			printf ("Homepage: http://www.bog.pp.ru/\n");
			printf ("\n");
			printf ("	Charset length: %d\n", CharsetLen);
#ifdef CharsetInterval
			printf ("	Charset interval\n");
#else
			printf ("	Charset: %s\n", szChars);
#endif
			printf ("	minimal password length: %d\n", PasswordLen_min);
			printf ("	maximal password length: %d\n", PasswordLen_max);
			printf ("	tasks queue length per thread: %d\n", queue_leng);
			printf ("	CPU numbers: %d\n", cpu_childs_num);
			printf ("	GPU numbers: %d\n", gpu_childs_num / threads_per_gpu);
			printf ("	CPUs threads priority: %d\n", cpu_nice);
			printf ("	GPUs threads priority: %d\n", gpu_nice);
			printf ("	CUDA sync pause: %d\n", sync_pause);
			printf ("	CPUs threads affinity: %d\n", cpu_affinity);
			printf ("	GPU threads affinity to CPU: %d\n", gpu_cpu);
			printf ("	threads per GPU: %d\n", threads_per_gpu);
			printf ("	tasks per GPU thread: %d\n", tasks_per_thread);
			printf ("\n");
		} else {
			printf ("CPUs threads: %d, GPUs threads: %d\n", cpu_childs_num, gpu_childs_num);
		}
//		if( sched_setaffinity (0, sizeof(cpu_set_t), &cpumask_parent) ) {
//			printf ("! sched_setaffinity error, parent\n");
//			return EXIT_FAILURE;
//		}

		nPasswordLen_host = PasswordLen_min-1-4;
		for (i = 0; i < nPasswordLen_host; i++) nPassword_host[i] = CharsetLen;
		while (1) {
// следующий пароль
			for (i=0; i<nPasswordLen_host; i++) {
				if (++nPassword_host[i] < CharsetLen) break;
				nPassword_host[i] = 0;
			}
			if (i == nPasswordLen_host) {
				nPasswordLen_host++;
				printf ("+ Password length: %ld\n", nPasswordLen_host+4);
				nPassword_host[i] = 0;
				if (nPasswordLen_host > PasswordLen_max-4) break;
			}

// выбор свободного исполнителя
			for (child_num = 0; child_num < cpu_childs_num+gpu_childs_num; child_num++)
				if (cpu_childs[child_num].queue < queue_leng) break;
// все заняты ? ждём результата
			if (child_num == cpu_childs_num+gpu_childs_num) {
				child_num = poll (poll_fds, cpu_childs_num+gpu_childs_num, -1);
				if (child_num <= 0) {
					printf ("! poll error\n");
					return EXIT_FAILURE;
				}
				for (child_num = 0; child_num < cpu_childs_num+gpu_childs_num; child_num++) {
					if (poll_fds[child_num].revents) break;
				}
				if ((rcount = read (cpu_childs[child_num].pipefd_result[0], &nPasswordLen_result,
					sizeof(nPasswordLen_result))) != sizeof(nPasswordLen_result)) {
					printf ("! read result header error, child: %d\n", child_num);
					return EXIT_FAILURE;
				}
				if ((rcount = read (cpu_childs[child_num].pipefd_result[0], nPassword_result,
					sizeof(nPassword_result[0]) * nPasswordLen_result))
						!= sizeof(nPassword_result[0]) * nPasswordLen_result) {
					printf ("! read result error, child: %d\n", child_num);
					return EXIT_FAILURE;
				}
				if ((rcount = read (cpu_childs[child_num].pipefd_result[0], &nResult[0],
					sizeof(nResult[0]))) != sizeof(nResult[0])) {
					printf ("! read result error, child: %d\n", child_num);
					return EXIT_FAILURE;
				}
				cpu_childs[child_num].queue--;
				count += CharsetLen*CharsetLen*CharsetLen*CharsetLen;
				if( nResult[0] != -1 ) {
					char szPassword[256] = { 0 };
					for( i = 0; i < nPasswordLen_result; i++ )
						szPassword[i] = hGetChar(nPassword_result[i]);
					szPassword[i++] = hGetChar(nResult[0] >> 24);
					szPassword[i++] = hGetChar((nResult[0] >> 16) & 0xFF);
					szPassword[i++] = hGetChar((nResult[0] >> 8) & 0xFF);
					szPassword[i++] = hGetChar(nResult[0] & 0xFF);
					printf( " + Password for " );
//					for( i = 0; i < 8; i++ ) printf( "%02x", cHash[i] );
					for( i = 0; i < 2; i++ ) printf( "%lx", bHash_host[i] );
					printf( " is \"%s\"\n", szPassword );
					return EXIT_SUCCESS;
				}
				cur = time( NULL );
				if (cur - prev > 10 ) {
					char szPassword[256] = { 0 };
					for( i = 0; i < nPasswordLen_result; i++ )
						szPassword[i] = hGetChar(nPassword_result[i]);
					printf( " + Current password from child %d: \"%s\"", child_num, szPassword );
					printf( ", avg. speed: %.2fM p/s\n", ((double)count)/(cur-start)/1e6 );
					prev = cur;
				}
			}
// запись задания на выполнение
			if ((wcount = write (cpu_childs[child_num].pipefd_task[1], &nPasswordLen_host,
				sizeof(nPasswordLen_host))) != sizeof(nPasswordLen_host)) {
				printf ("! write task header error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if ((wcount = write (cpu_childs[child_num].pipefd_task[1], nPassword_host,
				sizeof(nPassword_host[0]) * nPasswordLen_host)) 
					!= sizeof(nPassword_host[0]) * nPasswordLen_host) {
				printf ("! write task error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			cpu_childs[child_num].queue++;
		}
		printf ("- password not found\n");
		return EXIT_FAILURE;
	} else {
		for (i=0; i<child_num; i++) {
			close (cpu_childs[i].pipefd_task[0]);
			close (cpu_childs[i].pipefd_task[1]);
			close (cpu_childs[i].pipefd_result[0]);
			close (cpu_childs[i].pipefd_result[1]);
		}
		close (cpu_childs[child_num].pipefd_task[1]);
		close (cpu_childs[child_num].pipefd_result[0]);

		nPasswordLen_child_old = 0;
		nPasswordLen_child_old2 = 0;
		
		if (cpu_childs[child_num].gpu) {
			cudaRunAndCheck (cudaGetDeviceCount( &gpu_childs_num ), "cudaGetDeviceCount", 0);
			if (gpu_childs_num > used_gpu) gpu_childs_num = used_gpu;
			if( gpu_childs_num < 1 ) {
				printf( " ! No compatible device found(%d).\n", child_num );
				return EXIT_FAILURE;
			}
			printf( " + child: %d, Number of CUDA devices present: %d\n", child_num, gpu_childs_num );
//			cudaRunAndCheck (cudaGetDevice( &i ), "cudaGetDevice", child_num);
//			printf( " + child: %d, Device %d\n", child_num, i);
			cudaRunAndCheck (cudaGetDeviceProperties( &prop[child_num-cpu_childs_num], 
				(child_num-cpu_childs_num) / threads_per_gpu),
				"cudaGetDeviceProperties", child_num);
			printf( " + child: %d, Device %d(%s): %d MOP at %d MHz\n", child_num, 
				(child_num-cpu_childs_num) / threads_per_gpu,
				prop[child_num-cpu_childs_num].name, prop[child_num-cpu_childs_num].multiProcessorCount, 
				prop[child_num-cpu_childs_num].clockRate/1000);
			cudaRunAndCheck (cudaSetDevice( (child_num-cpu_childs_num) / threads_per_gpu), "cudaSetDevice", child_num);
			cudaRunAndCheck (cudaThreadSynchronize(), "cudaThreadSynchronize", child_num);
			cudaRunAndCheck (cudaStreamCreate( &stream ), "cudaStreamCreate", child_num);
			cudaRunAndCheck (cudaStreamCreate( &stream2 ), "cudaStreamCreate 2", child_num);

#ifndef CharsetInterval
			cudaRunAndCheck (cudaMemcpyToSymbol( "cCharset_GPU", nCharset_host, sizeof(nCharset_host) ),
				"cudaMemcpyToSymbol(cCharset_GPU)", child_num);
#endif
			cudaRunAndCheck (cudaMemcpyToSymbol( "bHash_GPU", bHash_host, sizeof(bHash_host) ), 
				"cudaMemcpyToSymbol(bHash_GPU)", child_num);
			nResult[0] = -1;
			nResult[1] = -1;
			if (((child_num-cpu_childs_num) % threads_per_gpu) == 0)
				if (tasks_per_thread > 1)
					cudaRunAndCheck (cudaMemcpyToSymbol( "ResultFlag_GPU", &nResult, sizeof(nResult) ),
					"cudaMemcpyToSymbol(ResultFlag_GPU)", child_num);
				else
					cudaRunAndCheck (cudaMemcpyToSymbol( "ResultFlag_GPU", &nResult, sizeof(nResult[0]) ),
					"cudaMemcpyToSymbol(ResultFlag_GPU[0])", child_num);
			else
				cudaRunAndCheck (cudaMemcpyToSymbol( "ResultFlag_GPU", &nResult[1], sizeof(nResult[1]), sizeof(nResult[0]) ),
				"cudaMemcpyToSymbol(ResultFlag_GPU[1])", child_num);
		}
		while (getppid() != 1) {
//			child_count++;
// чтение задания
			if ((rcount = read (cpu_childs[child_num].pipefd_task[0], &nPasswordLen_child,
				sizeof(nPasswordLen_child))) != sizeof(nPasswordLen_child)) {
				printf ("! read task header error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if ((rcount = read (cpu_childs[child_num].pipefd_task[0], nPassword_child,
				sizeof(nPassword_child[0]) * nPasswordLen_child)) 
					!= sizeof(nPassword_child[0]) * nPasswordLen_child) {
				printf ("! read task error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if (cpu_childs[child_num].gpu) {
				if (tasks_per_thread > 1) {
					if ((rcount = read (cpu_childs[child_num].pipefd_task[0], &nPasswordLen_child2,
						sizeof(nPasswordLen_child2))) != sizeof(nPasswordLen_child2)) {
						printf ("! read task header error, child2: %d\n", child_num);
						return EXIT_FAILURE;
					}
					if ((rcount = read (cpu_childs[child_num].pipefd_task[0], nPassword_child2,
						sizeof(nPassword_child2[0]) * nPasswordLen_child2)) 
							!= sizeof(nPassword_child2[0]) * nPasswordLen_child2) {
						printf ("! read task error, child: %d\n", child_num);
						return EXIT_FAILURE;
					}
				}
				if (nPasswordLen_child != nPasswordLen_child_old) {
				    if (((child_num-cpu_childs_num) % threads_per_gpu) == 0)
					cudaRunAndCheck (
					cudaMemcpyToSymbol( "nPasswordLen_GPU", &nPasswordLen_child, sizeof(nPasswordLen_child)),
					"cudaMemcpyToSymbol(nPasswordLen_GPU)", child_num);
				    else
					cudaRunAndCheck (
					cudaMemcpyToSymbol( "nPasswordLen_GPU2", &nPasswordLen_child, sizeof(nPasswordLen_child)),
					"cudaMemcpyToSymbol(nPasswordLen_GPU2)", child_num);
					nPasswordLen_child_old = nPasswordLen_child;
				}
				if (tasks_per_thread > 1) 
				if (nPasswordLen_child2 != nPasswordLen_child_old2) {
					cudaRunAndCheck (
					cudaMemcpyToSymbol( "nPasswordLen_GPU2", &nPasswordLen_child2, sizeof(nPasswordLen_child2)),
					"cudaMemcpyToSymbol(nPasswordLen_GPU2)", child_num);
					nPasswordLen_child_old2 = nPasswordLen_child2;
				}

				if (((child_num-cpu_childs_num) % threads_per_gpu) == 0)
				  cudaRunAndCheck (cudaMemcpyToSymbol( "nPassword_GPU", nPassword_child, sizeof(nPassword_child)),
					"cudaMemcpyToSymbol(nPassword_GPU)", child_num);
				else
				  cudaRunAndCheck (cudaMemcpyToSymbol( "nPassword_GPU2", nPassword_child, sizeof(nPassword_child)),
					"cudaMemcpyToSymbol(nPassword_GPU2)", child_num);
// !!! слить с предыдущей операцией - даёт 4% при CharsetLen=36
				if (tasks_per_thread > 1) {
				  cudaRunAndCheck (cudaMemcpyToSymbol( "nPassword_GPU2", nPassword_child2, sizeof(nPassword_child2)),
					"cudaMemcpyToSymbol(nPassword_GPU2)", child_num);
				}

				if (((child_num-cpu_childs_num) % threads_per_gpu) == 0) {
					if (tasks_per_thread <= 1) {
						if (nPasswordLen_child == 3) {
							MySQL_GPU_fast_7<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 4) {
							MySQL_GPU_fast_8<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 5) {
							MySQL_GPU_fast_9<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 6) {
							MySQL_GPU_fast_10<<< grid, CharsetLen, 0, stream >>>( );
						} else {
							MySQL_GPU_fast_univ<<< grid, CharsetLen, 0, stream >>>( );
						}
					} else {
						if (nPasswordLen_child == 3) {
							MySQL_GPUD_fast_7<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 4) {
							MySQL_GPUD_fast_8<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 5) {
							MySQL_GPUD_fast_9<<< grid, CharsetLen, 0, stream >>>( );
						} else if (nPasswordLen_child == 6) {
							MySQL_GPUD_fast_10<<< grid, CharsetLen, 0, stream >>>( );
						} else {
							MySQL_GPUD_fast_univ<<< grid, CharsetLen, 0, stream >>>( );
						}
					}
					cudaSync (sync_pause, child_num, stream);
					if (tasks_per_thread > 1)
						cudaRunAndCheck (cudaMemcpyFromSymbol( &nResult, "ResultFlag_GPU", 
							sizeof(nResult), 0, cudaMemcpyDeviceToHost),
							"cudaMemcpyFromSymbol(ResultFlag_GPU)", child_num);
					else
						cudaRunAndCheck (cudaMemcpyFromSymbol( &nResult[0], "ResultFlag_GPU", 
							sizeof(nResult[0]), 0, cudaMemcpyDeviceToHost),
							"cudaMemcpyFromSymbol(ResultFlag_GPU[0])", child_num);
				} else {
					if (nPasswordLen_child == 3) {
						MySQL_GPU2_fast_7<<< grid, CharsetLen, 0, stream >>>( );
					} else if (nPasswordLen_child == 4) {
						MySQL_GPU2_fast_8<<< grid, CharsetLen, 0, stream >>>( );
					} else if (nPasswordLen_child == 5) {
						MySQL_GPU2_fast_9<<< grid, CharsetLen, 0, stream >>>( );
					} else if (nPasswordLen_child == 6) {
						MySQL_GPU2_fast_10<<< grid, CharsetLen, 0, stream >>>( );
					} else {
						MySQL_GPU2_fast_univ<<< grid, CharsetLen, 0, stream >>>( );
					}
					cudaSync (sync_pause, child_num, stream);
					cudaRunAndCheck (cudaMemcpyFromSymbol( &nResult[0], "ResultFlag_GPU", 
						sizeof(nResult[0]), sizeof(nResult[0]), cudaMemcpyDeviceToHost),
						"cudaMemcpyFromSymbol(ResultFlag_GPU[1])", child_num);
				}
				if (nResult[0] != -1 ) {
// 3.5%
//					child_recount++;
					blockIdx_child.x = nResult[0] >> 24;
					blockIdx_child.y = (nResult[0] >> 16) & 0xFF;
					threadIdx_child.x = (nResult[0] >> 8) & 0xFF;
					threadIdx_child.y = nResult[0] & 0xFF;
					if (MySQL_CPU_check() == 0) nResult[0] = -1;
//					ResultFlag_child = -1;
//					MySQL_CPU();
//					nResult[0] = ResultFlag_child;
				}
				if (tasks_per_thread > 1) 
				if (nResult[1] != -1 ) {
//					child_recount++;
					blockIdx_child.x = nResult[1] >> 24;
					blockIdx_child.y = (nResult[1] >> 16) & 0xFF;
					threadIdx_child.x = (nResult[1] >> 8) & 0xFF;
					threadIdx_child.y = nResult[1] & 0xFF;
					if (MySQL_CPU_check() == 0) nResult[1] = -1;
//					ResultFlag_child = -1;
//					MySQL_CPU();
//					nResult[1] = ResultFlag_child;
				}
			} else {
	                        for (blockIdx_child.x=0; blockIdx_child.x < CharsetLen; blockIdx_child.x++) {
	                          for (blockIdx_child.y=0; blockIdx_child.y < CharsetLen; blockIdx_child.y++) {
	                            for (threadIdx_child.x=0; threadIdx_child.x < CharsetLen; threadIdx_child.x++) {
//					MySQL_CPU_fast();
//					MySQL_CPU();
//	                                MySQL_CPU_fast_SSE3_univ();
					if (nPasswordLen_child == 3) {
						MySQL_CPU_fast_SSE3_7();
					} else if (nPasswordLen_child == 4) {
	                                	MySQL_CPU_fast_SSE3_8();
					} else if (nPasswordLen_child == 5) {
						MySQL_CPU_fast_SSE3_9();
					} else if (nPasswordLen_child == 6) {
						MySQL_CPU_fast_SSE3_10();
					} else {
	                                	MySQL_CPU_fast_SSE3_univ();
					}
	                                if( ResultFlag_child != -1 ) {
//						child_recount++;
	                                        ResultFlag_child = -1;
	                                        MySQL_CPU();
	                                        if( ResultFlag_child != -1 ) break;
	                                }
	                            }
	                            if( ResultFlag_child != -1 ) break;
	                          }
	                          if( ResultFlag_child != -1 ) break;
	                        }
				nResult[0] = ResultFlag_child;
			}
// запись результата
			if ((wcount = write (cpu_childs[child_num].pipefd_result[1], &nPasswordLen_child,
				sizeof(nPasswordLen_child))) != sizeof(nPasswordLen_child)) {
				printf ("! write result header error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if ((wcount = write (cpu_childs[child_num].pipefd_result[1], nPassword_child,
				sizeof(nPassword_child[0]) * nPasswordLen_child)) 
					!= sizeof(nPassword_child[0]) * nPasswordLen_child) {
				printf ("! write result error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if ((wcount = write (cpu_childs[child_num].pipefd_result[1], &nResult[0],
				sizeof(nResult[0]))) != sizeof(nResult[0])) {
				printf ("! write result error, child: %d\n", child_num);
				return EXIT_FAILURE;
			}
			if (cpu_childs[child_num].gpu)
			if (tasks_per_thread > 1) {
				if ((wcount = write (cpu_childs[child_num].pipefd_result[1], &nPasswordLen_child2,
					sizeof(nPasswordLen_child2))) != sizeof(nPasswordLen_child2)) {
					printf ("! write result header error, child2: %d\n", child_num);
					return EXIT_FAILURE;
				}
				if ((wcount = write (cpu_childs[child_num].pipefd_result[1], nPassword_child2,
					sizeof(nPassword_child2[0]) * nPasswordLen_child2)) 
						!= sizeof(nPassword_child2[0]) * nPasswordLen_child2) {
					printf ("! write result error, child2: %d\n", child_num);
					return EXIT_FAILURE;
				}
				if ((wcount = write (cpu_childs[child_num].pipefd_result[1], &nResult[1],
					sizeof(nResult[1]))) != sizeof(nResult[1])) {
					printf ("! write result error, child2: %d\n", child_num);
					return EXIT_FAILURE;
				}
			}
//if ((child_count % 1000) == 0)
//	printf ("child %d statistic - fast: %lld full: %lld\n", child_num, child_count, child_recount);

		};
		printf ("parent die, child pid: %d\n", getpid());
		cudaStreamDestroy( stream );
		usleep (1000);
		exit (EXIT_FAILURE);
	};
}

