// Brute force the Ripper - MySQL 3 password cracker (CUDA+SSE3)
// Copyright (c) 2008 by Sergey E. Bogomolov
// Homepage: http://www.bog.pp.ru/
//
// This version of "Brute force the Ripper - MySQL 3" is hereby being made available to you
// under the terms of the GNU General Public License version 2 as published
// by the Free Software Foundation.
//
// "Brute force the Ripper - MySQL 3" is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// выбор варианта компиляции
#define SSE3

#define CharsetLen 94
// варианты интервалов: 26, 75, 94
#define CharsetInterval

#define FMUL(a,b) (__umul24((a), (b)))
#define FMULhost(a,b) ((a)*(b))

#define THREADS_PER_GPU_MAX 2
#define TASKS_PER_THREAD_MAX 2

// значения параметров, принимаемых по умолчанию

#define GPU_SETSIZE 2

#define PasswordLen_Min 5 /* minimum 5 */
#define PasswordLen_Max 16

#define CPU_NICE 19
#define GPU_NICE 1

#define SYNC_PAUSE 0

#define GPU_CPU 3

#define THREADS_PER_GPU 1
#define TASKS_PER_THREAD 2

#define QUEUE_LENG 6

// дальше менять нечего

#ifdef CPU
#define _GNU_SOURCE
#endif

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sched.h>
#include <getopt.h>

#ifdef GPU
/* #include <cutil.h> */
#include <cuda_runtime.h>
__constant__ unsigned long nPasswordLen_GPU;
__constant__ unsigned long nPassword_GPU[16];
__device__ long ResultFlag_GPU[2];
__constant__ unsigned long cCharset_GPU[256];
__constant__ unsigned long bHash_GPU[2];

__constant__ unsigned long nPasswordLen_GPU2;
__constant__ unsigned long nPassword_GPU2[16];
// __device__ long ResultFlag_GPU2;
#endif

struct dim3_child { unsigned short x, y, z; };
struct dim3_child blockIdx_child, threadIdx_child;

unsigned long nPasswordLen_host;
unsigned long nPasswordLen_result;
unsigned long nPasswordLen_child;
unsigned long nPasswordLen_child_old;
unsigned long nPasswordLen_child2;
unsigned long nPasswordLen_child_old2;

unsigned long nPassword_host[16];
unsigned long nPassword_result[16];
unsigned long nPassword_child[16];
unsigned long nPassword_child2[16];

long ResultFlag_host;
long ResultFlag_child;
long ResultFlag_child2;

#ifdef CharsetInterval
  #if CharsetLen==26
    #define GetChar(n) ((n)+'a')
    #define hGetChar(n) ((n)+'a')
  #else
    #if CharsetLen==75
      #define GetChar(n) ((n)+'0')
      #define hGetChar(n) ((n)+'0')
    #else
      #undef CharsetLen
      #define CharsetLen 94
      #define GetChar(n) ((n)+'!')
      #define hGetChar(n) ((n)+'!')
    #endif
  #endif
#else
  #define GetChar(n) (cCharset_GPU[n])
  #define hGetChar(n) (cCharset_host[n])
  #define szChars "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-_`~!@#$%^&*()+=[]{};':"",./\\<>?|"
  unsigned char cCharset_host[256];
#endif

unsigned long bHash_host [2];

#ifndef CPU
extern "C" void MySQL_CPU_fast_SSE3_init();
extern "C" void MySQL_CPU_fast_SSE3_univ();
extern "C" void MySQL_CPU_fast_SSE3_7();
extern "C" void MySQL_CPU_fast_SSE3_8();
extern "C" void MySQL_CPU_fast_SSE3_9();
extern "C" void MySQL_CPU_fast_SSE3_10();
extern "C" void MySQL_CPU_fast();
extern "C" void MySQL_CPU();
extern "C" int MySQL_CPU_check();
#endif
